obj/Screen/mnuText
	icon='Text.dmi'
	layer=11
	name=""
	var/mnu=null

mob/var
	Clo="white"
	Size="big"

mob/var/list/strlist=list()
mob/var/list/letterlist=list()
var/list/LetterWidth=list("A"=13,"B"=10,"C"=10,"D"=13,"E"=8,"F"=7,"G"=11,"H"=13,"I"=5,"J"=8,"K"=12,"L"=8,"M"=18,"N"=11,"O"=12,"P"=9,"Q"=13,"R"=11,"S"=7,"T"=11,"U"=12,"V"=11,"W"=16,"X"=12,"Y"=12,"Z"=11,"a"=8,"b"=9,"c"=7,"d"=9,"e"=7,"f"=8,"g"=8,"h"=10,"i"=5,"j"=5,"k"=11,"l"=5,"m"=15,"n"=10,"o"=8,"p"=9,"q"=9,"r"=7,"s"=5,"t"=7,"u"=10,"v"=9,"w"=13,"x"=9,"y"=8,"z"=8,"0"=8,"1"=6,"2"=7,"3"=7,"4"=9,"5"=8,"6"=8,"7"=8,"8"=7,"9"=8,"."=2,"-"=5,","=3,"+"=9,"*"=9,")"=6,"("=6,"'"=3,"&"=13,"%"=14,"$"=7,"#"=10,{"""}=8,"!"=3,"{"=5,"|"=1,"}"=5,"~"=10,"/"=7,"\\"=7,">"=10,"<"=10,"_"=10,"\]"=5,"\["=5,"^"=9,"`"=3,"="=10,":"=2,";"=3)
var/list/SmallBoldLetterWidth=list("A"=7,"B"=7,"C"=7,"D"=7,"E"=6,"F"=6,"G"=7,"H"=6,"I"=3,"J"=5,"K"=6,"L"=5,"M"=9,"N"=7,"O"=7,"P"=6,"Q"=7,"R"=7,"S"=6,"T"=6,"U"=7,"V"=7,"W"=9,"X"=7,"Y"=7,"Z"=6,"a"=5,"b"=6,"c"=5,"d"=6,"e"=5,"f"=4,"g"=6,"h"=5,"i"=3,"j"=3,"k"=5,"l"=3,"m"=7,"n"=5,"o"=6,"p"=6,"q"=6,"r"=4,"s"=5,"t"=4,"u"=5,"v"=5,"w"=7,"x"=5,"y"=5,"z"=5,"0"=6,"1"=4,"2"=6,"3"=6,"4"=6,"5"=5,"6"=6,"7"=5,"8"=6,"9"=6,"."=3,"-"=4,","=3,"+"=5,"*"=4,")"=4,"("=4,"'"=3,"&"=5,"%"=6,"$"=5,"#"=7,{"""}=5,"!"=3,"{"=4,"|"=3,"}"=4,"~"=5,"/"=4,"\\"=4,">"=5,"<"=5,"_"=6,"\]"=4,"\["=4,"^"=5,"`"=4,"="=5,":"=3,";"=3)
var/list/SmallLetterWidth=list("A"=6,"B"=6,"C"=6,"D"=6,"E"=5,"F"=5,"G"=6,"H"=5,"I"=2,"J"=4,"K"=5,"L"=4,"M"=8,"N"=6,"O"=6,"P"=5,"Q"=6,"R"=6,"S"=5,"T"=5,"U"=6,"V"=6,"W"=8,"X"=6,"Y"=6,"Z"=5,"a"=4,"b"=5,"c"=4,"d"=5,"e"=4,"f"=3,"g"=5,"h"=4,"i"=2,"j"=2,"k"=4,"l"=3,"m"=6,"n"=4,"o"=5,"p"=5,"q"=5,"r"=3,"s"=4,"t"=3,"u"=4,"v"=4,"w"=6,"x"=4,"y"=4,"z"=4,"0"=5,"1"=3,"2"=5,"3"=5,"4"=5,"5"=4,"6"=5,"7"=4,"8"=5,"9"=5,"."=2,"-"=3,","=2,"+"=4,"*"=3,")"=3,"("=3,"'"=2,"&"=4,"%"=5,"$"=4,"#"=6,{"""}=4,"!"=2,"{"=3,"|"=2,"}"=3,"~"=4,"/"=3,"\\"=3,">"=4,"<"=4,"_"=5,"\]"=3,"\["=3,"^"=4,"`"=3,"="=4,":"=2,";"=2)
var/list/Colors=list("black"=rgb(255,255,255),"blue"=rgb(255,255,0),"brown"=rgb(100,200,250),"cyan"=rgb(255,0,0),"grey"=rgb(125,125,125),"green"=rgb(255,0,255),"light green"=rgb(125,0,125),"pink"=rgb(50,200,130),"purple"=rgb(100,250,150),"red"=rgb(0,255,255),"tan"=rgb(255,255,0),"yellow"=rgb(0,0,255))

mob/proc
	SplitStrings(str as text)
		src.strlist=list()
		var/x=1;var/x2=1;var/tword=null;var/tlength=length("[str]")
		while(tlength)
			if(copytext(str,x,x2+1)!=" ")tword+=copytext(str,x,x2+1)
			else if(copytext(str,x,x2+1)==" ")
				src.strlist.Add(tword);tword=null
			x++;x2++;tlength--
		src.strlist.Add(tword)
	Scribe(t as text,x as num,y as num,x2 as num,y2 as num,id=null as text,n=null as text,px=0 as num,py=0 as num,l=11 as num,var/s=0 as num,color=null as text,var/size="big" as text)
		var/listpos=1;var/tpx=0;var/tx=0;var/sx=x;var/spx=px;var/i=0;var/stop=0;if(y==y2)stop++
		SplitStrings(t)
		for(var/str in src.strlist)i++
		while(i)
			src.letterlist=list();tpx=0;tx=0
			for(var/len=1,len<length(src.strlist[listpos])+1,len++)
				src.letterlist+=copytext(src.strlist[listpos],len,len+1)
				if(size=="big")tpx+=LetterWidth["[copytext(src.strlist[listpos],len,len+1)]"]+1
				else if(size=="small")tpx+=SmallLetterWidth["[copytext(src.strlist[listpos],len,len+1)]"]+1
				else if(size=="small bold")tpx+=SmallBoldLetterWidth["[copytext(src.strlist[listpos],len,len+1)]"]+1
				if(tpx+px+8>32)
					tpx-=32;tx++
					if(x+tx>x2)
						py-=15;x=sx;px=spx
						if(stop>=1)return
						if(py<=-32)
							py+=32;y--;px=spx
							if(y==y2)stop++
							if(y<y2)return
			for(var/str in src.letterlist)
				var/obj/Screen/mnuText/o=new
				if(size=="big")o.icon='Text.dmi'
				else if(size=="small")o.icon='Small Text.dmi'
				else if(size=="small bold")o.icon='Small Bold Text.dmi'
				o.icon_state="[str]";o.name=n
				if(s==1)sleep(1)
				o.screen_loc="[x]:[px],[y]:[py]"
				o.layer=l;o.mnu=id
				if(color!=null&&color!="white")o.icon -= Colors["[color]"]
				src.client.screen+=o
				if(size=="big")px+=LetterWidth["[str]"]+1
				else if(size=="small")px+=SmallLetterWidth["[str]"]+1
				else if(size=="small bold")px+=SmallBoldLetterWidth["[str]"]+1
				if(px-8>=32)
					px-=32;x++
					if(x>x2)
						x=sx;py-=15;px=spx
						if(py<=-32)
							py+=32;y--;px=spx
							if(y<y2)return
			if(size=="big")px+=8
			else if(size=="small")px+=2
			if(px-8>=32)
				px-=32;x++
				if(x>x2)
					x=sx;py-=15;px=spx
					if(py<=-32)
						py+=32;y--;px=spx
						if(y<y2)return
			i--;listpos++
	CloseText(id as text)
		if(lowertext(id)=="all")for(var/obj/Screen/mnuText/o in src.client.screen)del(o)
		else for(var/obj/Screen/mnuText/o in src.client.screen)if(o.mnu==id)del(o)
